package hr.pmf.abkloubcar.drd;

import hr.pmf.abkloubcar.drd.model.Node;

import java.util.List;

public class InitialWeightsSolver {

    public enum InitialWeightsVariant {
        WEIGHTS_3_0("WEIGHTS_3_0"),
        WEIGHTS_2_1("WEIGHTS_2_1");

        private final String text;

        InitialWeightsVariant(final String text) {
            this.text = text;
        }

        @Override
        public String toString() {
            return text;
        }

    }

    public static void process(List<Node> graph, InitialWeightsVariant variant) {
        switch (variant) {
            case WEIGHTS_3_0 -> {
                variant30(graph);;
            }
            case WEIGHTS_2_1 -> {
                variant21(graph);;
            }
        }
    }
    private static void variant30(List<Node> graph) {
        graph.forEach(node -> {
            if (node.dominating) {
                node.weight = 3;
            } else {
                node.weight = 0;
            }
        });
    }

    private static void variant21(List<Node> graph) {
        graph.forEach(node -> {
            if (node.dominating) {
                node.weight = 2;
            } else {
                node.weight = 1;
            }
        });
    }
}
