package hr.pmf.abkloubcar.drd.util;

import hr.pmf.abkloubcar.drd.DominatingSetSolver;
import hr.pmf.abkloubcar.drd.InitialWeightsSolver;
import hr.pmf.abkloubcar.drd.model.Node;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Util {

    public static String LOG_LEVEL = "INFO";
    public static String RESOURCES = "resources";
    public static String INPUT_FOLDER = "input";

    public static void log(String input) {
        log(input, "INFO");
    }

    public static void createFileIfNotExisting(String folder, String file) throws IOException {
        if (!Files.exists(Paths.get(RESOURCES, folder))) {
            Files.createDirectory(Paths.get(RESOURCES, folder));
        }
        if (!Files.exists(Paths.get(RESOURCES, folder, file))) {
            Files.createFile(Paths.get(RESOURCES, folder, file));
        }
    }

    public static void resetFile(String folder, String file) throws IOException {
        Files.write(Paths.get(RESOURCES, folder, file), "".getBytes());
    }

    public static void appendToFile(String folder, String file, String data, boolean newline) throws IOException {
        Files.write(Paths.get(RESOURCES, folder, file), (newline ? (data + "\n") : data).getBytes(), StandardOpenOption.APPEND);
    }

    public static void log(String input, String currentLevel) {
        if (LOG_LEVEL.equals("DEBUG")) {
            System.out.println(input);
        } else if (currentLevel.equals(LOG_LEVEL)) {
            System.out.println(input);
        }
    }

    public static String getCsv(String name, long preparationTime, long totalTime, int initialCost, int endCost, float cplexTime, int cplexCost) {
        return Stream.of(
                name,
                cplexCost,
                endCost,
                Math.round((((endCost - cplexCost) * 1.0) / cplexCost) * 10000.0) / 100.0,
                Math.round(cplexTime),
                totalTime,
                Math.round(((cplexTime / totalTime) * 1.0)  * 100) / 100.0
        ).map(item -> item + "").collect(Collectors.joining(",")) + "\n";
    }

}
